var $u = require('util')
var DatastoreBase = require('./DatastoreBase')
var sql = require('mssql')
var lexer = require('sql-parser')

$u.inherits(MssqlDatastore, DatastoreBase)

function MssqlDatastore(config) {
	DatastoreBase.call(this, config)
}

/*

*/
MssqlDatastore.prototype.create = function(callback) {
	this._connection = new sql.Connection(this.config, function(err) {
		if (err) return callback(err)

		var self = this
		this.createQuery('select 1=1', function(err, query, connection) {
			if (err)
				return callback(err)

			//self.timezone = connection.config.timezone

			query.on('end', function() {
				callback(null, self)
			})

			query.on('error', function(err) {
				callback(err)
			})
		})
	})
}

/*
	run the query and execute callback with results
*/
MssqlDatastore.prototype.query = function(sql, values, callback) {
	// if isSelect && values
	var request = new sql.Request(connection) // or: var request = connection.request() 
	request.query(sql, function(err, recordset) {
		// ... error checks 
		console.dir(recordset)
	})
}

MssqlDatastore.prototype._parseNamedParameters = function(sql) {
	var tokens = lexel.tokenize(sql)

}

MssqlDatastore.prototype._isSelectQuery = function(sql) {
	return sql.indexOf('SELECT') === 0
}

/*
	run the query and execute callback with a query instance
*/
MssqlDatastore.prototype.createQuery = function(sql, values, callback) {
	var request = new sql.Request()
	request.stream = true // You can set streaming differently for each request 
	request.query('select * from verylargetable') // or request.execute(procedure) 

	request.on('recordset', function(columns) {
		// Emitted once for each recordset in a query 
	})

	request.on('row', function(row) {
		// Emitted for each row in a recordset 
	})

	request.on('error', function(err) {
		// May be emitted multiple times 
	})

	request.on('done', function(returnValue) {
		// Always emitted as the last one 
	})
}

MssqlDatastore.prototype.formatValue = function(val) {

}

module.exports = MssqlDatastore
